#include "ds18b20.h"						//
//--------------------------------------------------------------------------------------- 

volatile char CONV; 			//    
volatile char ds18b20;		//   
volatile char minus;         //   
volatile char CONFLAG;					// 
volatile char crc;

void Level_High(void)
{
	DALLAS=1;				//          
	__delay_us(6);			// 10         
	TRISDAL=1;				//     
}

//========================================================================================
// Level_LOW:     
void Level_Low(void)
{
	DALLAS=0;				//    			
	TRISDAL=0;				//    
	__delay_us(1);			// 3   
}//---------------------------------------------------------------------------------------

//========================================================================================
// DLIT_WR:   
//  60 mks,    DS1820      .
void Waiting_WR(void)
{
	__delay_us(52);			//52   
}//---------------------------------------------------------------------------------------

//========================================================================================
//crc_bits:    crc8  DS18B20
char CRC_Bits(int data) 
{
  int i = (data ^ crc) & 0xff;
  crc = 0;
	  if(i & 0b00000001)crc ^= 0x5e;
	  if(i & 0b00000010)crc ^= 0xbc;
	  if(i & 0b00000100)crc ^= 0x61;
	  if(i & 0b00001000)crc ^= 0xc2;
	  if(i & 0b00010000)crc ^= 0x9d;
	  if(i & 0b00100000)crc ^= 0x23;
	  if(i & 0b01000000)crc ^= 0x46;
	  if(i & 0b10000000)crc ^= 0x8c;
  return crc;
}//---------------------------------------------------------------------------------------





//========================================================================================
//RESET_DALLAS:      
//  	0 -    
//				1 -      ()
//				2 -       ()
char Reset_Dallas(void)
{
char ERR_LINE; //     c
unsigned char a;
			Level_Low();				//   >480 mks
			__delay_us(700);			// 700 mks

//   ,    
			ERR_LINE=0;//    -     c
			di();// 			

//tttt3:		di();					//  
//			if(GIE==1)goto tttt3;	//  

			Level_High();				//  
		//	__delay_us(15);				// 15 mks
		//     
			a=0;
			while (ERR_LINE==0&&DALLAS==1)
			{
				CLRWDT(); 
				__delay_us(5);			// 5 mks
				if(++a>120)ERR_LINE=1; 	//   -   
			}	 
			ei();// 

		//    ,   	
			a=0;
			while (ERR_LINE==0&&DALLAS==0)
			{
				CLRWDT(); 
				__delay_us(5);			// 5 mks
				if(++a>120)ERR_LINE=2; 	//   -   
			}	 
			
			__delay_us(700);			//  >480 mks

// ,    		
			//if(ERR_LINE>0)
			//{
			//	error_con++;//  
			//	if(error_con<25 && TESTDT==0)ERR_LINE=0;//     
			//}	
			//else error_con=0;// 
			
		//	ERR_LINE=0;//test alarm
		return ERR_LINE;
}//---------------------------------------------------------------------------------------




//========================================================================================
// Dreceive:      DS18B20.
char Dreceive (void)
{
char COM_REG,a;	
	COM_REG=0;
	for (a=0; a<8; a++)						//     
	{										//
tttt0:	di();					//  
		if(GIE==1)goto tttt0;	//  
		Level_Low ();						//      )
		Level_High ();						//  
		COM_REG=COM_REG>>1;					//  +   7  0
		if (DALLAS==1)COM_REG |= 0b10000000;//   7  1  DALLAS==1
		ei();	//   
		Waiting_WR();						//     
	}
return COM_REG;
}//---------------------------------------------------------------------------------------

//========================================================================================
// Dsend:      DS1820.
void Dsend(char COM_REG) 
{
char a;
	for (a=0; a<8; a++)	
	{
tttt1:	di();					//  
		if(GIE==1)goto tttt1;	//  
		Level_Low ();		
		if(COM_REG & 0b00000001) Level_High ();
		COM_REG=COM_REG>>1;	
		ei();	//   
		Waiting_WR ();
	 	Level_High ();
	}
}//---------------------------------------------------------------------------------------

unsigned char init_temp()
{  
    unsigned char b;
    b=Reset_Dallas();
    if(!b)
    {
        //  ,    , =00 
        //9  , 100 
        Dsend(0xcc);
        Dsend(0x4e);//    
        Dsend(0x00);
        Dsend(0x00);
        Dsend(0x00);
        Level_High ();
        return 0;
    }
    else
        return 1;
}

//========================================================================================
/*celsio:      .   
   ,  ,      EEPROM 
 .     . 
 
NACHAD -     
COLDAT -   

// 
//  0;  //     
//  1; //  
//  2; //  
//  3; //    -        
//  4; //    -    
//  5; //   
*/
char Celsio (void)
{
char a, nomdat; //   



unsigned char temper;
unsigned char MINUS;
unsigned char LS_byte;
unsigned char MS_byte;
unsigned char temp=0;

	if(CONFLAG==1)//    
	{
			if(CONV==0)	CONFLAG=0;
 		else return 2; //  
	}
	else
	{
		a=Reset_Dallas();//   
		if (a==0)
		{
            Dsend(0xCC);//    
            Dsend(0xBE); 			//   
            crc=0; 					//    			
            LS_byte=Dreceive(); 	//   01
            CRC_Bits(LS_byte);
            MS_byte=Dreceive(); 			//   02
            //      
            LS_byte&=0xf0;
            LS_byte>>=4;
            LS_byte&=0x0f;
   
            temp=MS_byte;
            MS_byte&=0x0f; //0x07=0000 0111
            MS_byte<<=4;
   
            if(temp&0xf0)
            {
                temp=0x01; // 
                LS_byte=LS_byte|MS_byte;
                LS_byte=(~LS_byte)+1;
            }
            else
            {
                temp=0;    // 
                LS_byte=LS_byte|MS_byte;
            }
  
            ds18b20=LS_byte;
            minus=temp;	
            
            CRC_Bits(MS_byte);
            CRC_Bits(Dreceive()); 	//   03
            CRC_Bits(Dreceive()); 	//   04
            CRC_Bits(Dreceive()); 	//   05
            CRC_Bits(Dreceive()); 	//   06
            CRC_Bits(Dreceive()); 	//   07
            CRC_Bits(Dreceive()); 	//   08
            CRC_Bits(Dreceive()); 	//   09
            //   
            Reset_Dallas();//   
			Dsend (0xCC);//    
			Dsend (0x44);//  
			CONV=1;
			CONFLAG=1;
		 	return 1; // 
		}
		else
		{
			if (a==1) return 3; //  - ,     )
			else return 4; //  -   ( )
		}
	}
//  ,      	
		if(crc!=0)		// 0=      <10
		{
			
		}	
		
	return 0;
}//---------------------------------------------------------------------------------------

